---------PvPGrid by Unrealrules-Eredar ----------


PvPGrid = LibStub("AceAddon-3.0"):NewAddon("PvPGrid", "AceConsole-3.0","AceEvent-3.0", "AceComm-3.0", "AceTimer-3.0")

local testmode = false
-- "WenQuanYi Zen Hei" supports all regions but over 10 Megabyte LOL
-- local LSM = LibStub("LibSharedMedia-3.0")
-- local koKR, ruRU, zhCN, zhTW, western = LSM.LOCALE_BIT_koKR, LSM.LOCALE_BIT_ruRU, LSM.LOCALE_BIT_zhCN, LSM.LOCALE_BIT_zhTW, LSM.LOCALE_BIT_western
-- local MediaType_FONT = LSM.MediaType.FONT
-- LSM:Register(
	-- MediaType_FONT, "SempliceRegular",
	-- [[Interface\Addons\PvPGrid\SempliceRegular.ttf]],	
	-- koKR + ruRU + zhCN + zhTW + western)
	
local media = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("PvPGrid")

media:Register("statusbar", "BantoBar", [[Interface\Addons\PvPGrid\media\BantoBar]])
		
function PvPGrid:formatUpToX(s, x)
	x = x or 79
	local t = {""}
	local length = string.len(s)
	if length > x then
		local cut = string.find(s, "-") or 99
		t[1] = string.sub(s, 1, cut)
		t[2] = string.sub(s, cut+1)
	else
		t[1] = s
	end
	return table.concat(t, "\n")
end

PvPGrid.targets = {}
PvPGrid.loopq = 0

local dbDefaults = {
	profile = {	
		lock = false,
		frameheight = 20,
		framewidth = 225,
		fontsize = 17,
		mainfont = "Arial Narrow",
		statusbarframe = "BantoBar",
		servername = true ,
		roleicon = true,
		specicon = true,
		barcolor = false,
		leftbuttontype = 'TARGET',
		leftbutton = '',
		rightbuttontype = 'FOCUS',
		rightbutton = '',
		middlebuttontype = 'MOUSEOVER',
		middlebutton = '',
		percenttext = 'PERCENT',
		wordwrap = 99,
	}
}

function PvPGrid:OnInitialize()
	PvPGrid.db = LibStub("AceDB-3.0"):New("PvPGridDB", dbDefaults)
	self:getClassInfos()
	self:createdisplay()
	
	self:SetupOptions()
end

function PvPGrid:getClassInfos()
	self.Classinfos = {}
	for i = 1, MAX_CLASSES do
		local _, classnumber = GetClassInfoByID(i)
		local specnumbers = GetNumSpecializationsForClassID(i)

		self.Classinfos[classnumber] = {}
		for j = 1, specnumbers do
			local _,name,_,icon,role = GetSpecializationInfoForClassID(i, j)
			self.Classinfos[classnumber][j] = {specname = name, specicon = icon, specrole = role}
		end
	end
end

function PvPGrid:createplayer()
	self.player = {}
	self.player.faction = ''
	self.player.name, self.player.server = UnitFullName('player')
end

function PvPGrid:update_player()
	local playernumbers = GetNumBattlefieldScores()
	for i = 1, playernumbers do
		local name,_,_,_,_,faction,_,_,class,_ ,_,_,_,_,_,spec = GetBattlefieldScore(i)
		if PvPGrid.player then
			if name == PvPGrid.player.name then
				PvPGrid.player.faction = faction 
			end
		else
			self:createplayer()
		end
	end
end

function PvPGrid:OnEnable()
	self:createplayer()
	--self.playergrid = {}
	
	
	self.playerinfos = {}
	self.mainframe:RegisterEvent('ZONE_CHANGED_NEW_AREA')
	self.mainframe:RegisterEvent('UPDATE_BATTLEFIELD_SCORE')
	self.mainframe:RegisterEvent('UNIT_TARGET')
	self.mainframe:RegisterEvent('UNIT_HEALTH_FREQUENT')
	self.mainframe:RegisterEvent('NAME_PLATE_UNIT_ADDED')
	self.mainframe:RegisterEvent('NAME_PLATE_UNIT_REMOVED')
	self.mainframe:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
	
	self.mainframe:SetScript('OnEvent', PvPGrid_OnEvent)
	self:PvP_Zone_check()
	self:OnOptionCreate()
end

function PvPGrid:createdisplay()
	
	self:create_mainframe()
	self:create_playerframes()
	self:create_flags_and_orbs()
	self:showgrid()
	if not testmode then
		self.mainframe:Hide()
	end
end

function PvPGrid:create_flags_and_orbs()
	local height = self.db.profile.frameheight 
	local fontsize = self.db.profile.fontsize 
	
	local frame = 'allianceflag'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\WorldStateFrame\AllianceFlag]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'hordeflag'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\WorldStateFrame\HordeFlag]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'netherflag'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\WorldStateFrame\ColumnIcon-FlagCapture2]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	
	frame = 'blueorb'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\inv_misc_enchantedpearlF]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'purpleorb'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\inv_misc_enchantedpearlD]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'orangeorb'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\inv_misc_enchantedpearlC]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'greenorb'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\inv_misc_enchantedpearlA]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'purple_dunkball'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\ability_deepwinddunk_ball_purple]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'orange_dunkball'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\ability_deepwinddunk_ball]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'green_dunkball'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\ability_deepwinddunk_ball_green]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
		
end

function PvPGrid:setflag(frame_id, number)
	local height = self.db.profile.frameheight 
	self.mainframe[frame_id]:Show()
	self.mainframe[frame_id]:SetPoint("TOPLEFT", -height*3-3, -(number-1)*height-10)
	self.mainframe[frame_id].fontname:SetPoint("TOPLEFT", -height*4-3-10, -(number-1)*height-10-height/4)
	self.mainframe[frame_id].fontname:Show()
end

function PvPGrid:HideFlag(frame_id)
	self.mainframe[frame_id]:Hide()
	self.mainframe[frame_id].fontname:Hide()
end

function PvPGrid:create_mainframe()
	PvPGrid.mainframe = CreateFrame("Frame", 'MainFrame_PvPGrid', UIParent)
	PvPGrid.mainframe:SetPoint("Center", 0, 300)
	PvPGrid.mainframe:SetSize(150, 10)
	PvPGrid.mainframe:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", tile = true, tileSize = 8 })
	PvPGrid.mainframe:SetBackdropColor(0.5, 0.5, 0.5, 0.3)
	PvPGrid.mainframe:SetMovable(true)
	if PvPGrid.db.profile.lock then
		PvPGrid.mainframe:EnableMouse(false)
	else
		PvPGrid.mainframe:EnableMouse(true)
	end	
	PvPGrid.mainframe:RegisterForDrag("LeftButton")
	PvPGrid.mainframe:SetScript("OnDragStart", PvPGrid.mainframe.StartMoving)
	PvPGrid.mainframe:SetScript("OnDragStop", PvPGrid.mainframe.StopMovingOrSizing)
	PvPGrid.mainframe:SetUserPlaced(true)
	
	PvPGrid.mainframe:SetScript("OnUpdate", function(self, frame) 
		-- if PvPGrid.loopq ~= 0 then
			-- local time = GetTime()
			-- local dataTIme = PvPGrid.loopq + 1
			-- if time > dataTIme then
				-- print(GetTime()..'true')
			-- else
				-- print(GetTime()..'false')
			-- end
		-- end
		local showflag_alliance = false
		local showflag_horde = false
		local showflag_nether = false
		
		local showorb_blue = false
		local showorb_purple = false
		local showorb_orange = false
		local showorb_green = false
		
		local purple_dunkball = false
		local orange_dunkball = false
		local green_dunkball = false
		
		if testmode then
			showorb_blue = true
			showorb_purple = true
			showorb_orange = true
			showorb_green = true
		end
		for j= 1 , 4 , 1 do
			for i = 1, 40 ,1 do
				local currentMapId = GetCurrentMapAreaID()
				local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, canStealOrPurge, nameplateShowPersonal, spellId = UnitAura('arena'..j, i)
				
				if spellId == 156618 or spellId == 141210 then -- hordeflag
					local targetname, targetserver = UnitFullName('arena'..j)
					if targetserver == nil then
					
					else
						targetname = targetname..'-'..targetserver 
					end
					local playernumber = PvPGrid:getPlayernumber(targetname)
					if playernumber ~= 0 then
						PvPGrid:setflag('hordeflag', playernumber)
						showflag_horde = true
						for k = 1 , 15 , 1 do
							local spellId2 = select(11, UnitDebuff('arena'..j, k))
							local count = select(4, UnitDebuff('arena'..j, k))
							if spellId2 == 46392 or spellId2 == 46393 then
								local text = 'x'.. 1+count/10
								PvPGrid.mainframe['hordeflag'].fontname:SetText(text)
								break
							else
								local text = 'x'.. 1 .. '.0'
								PvPGrid.mainframe['hordeflag'].fontname:SetText(text)
							end
						end
					end
				end
				if spellId == 156621 or spellId == 140876 then -- allianceflag
					local targetname, targetserver = UnitFullName('arena'..j)
					if targetserver == nil then
					
					else
						targetname = targetname..'-'..targetserver 
					end
					local playernumber = PvPGrid:getPlayernumber(targetname)
					if playernumber ~= 0 then
						PvPGrid:setflag('allianceflag', playernumber)
						showflag_alliance = true
						for k = 1 , 15 , 1 do
							local spellId2 = select(11, UnitDebuff('arena'..j, k))
							local count = select(4, UnitDebuff('arena'..j, k))
							if spellId2 == 46392 or spellId2 == 46393 then
								local text = 'x'.. 1+count/10
								PvPGrid.mainframe['allianceflag'].fontname:SetText(text)
								break
							else
								local text = 'x'.. 1 .. '.0'
								PvPGrid.mainframe['hordeflag'].fontname:SetText(text)
							end
						end
					end
				end
				if spellId == 34976 then -- netherflag
					local targetname, targetserver = UnitFullName('arena'..j)
					if targetserver == nil then
					
					else
						targetname = targetname..'-'..targetserver 
					end
					local playernumber = PvPGrid:getPlayernumber(targetname)
					if playernumber ~= 0 then
						PvPGrid:setflag('netherflag', playernumber)
						showflag_nether = true
					end
				end
				if spellId == 231529 then -- purple-dunkball
					--print('purple-dunkball')
					local targetname, targetserver = UnitFullName('arena3')
					if targetserver == nil then
					
					else
						targetname = targetname..'-'..targetserver 
					end
					local playernumber = PvPGrid:getPlayernumber(targetname)
					if playernumber ~= 0 then
						PvPGrid:setflag('purple_dunkball', playernumber)
						purple_dunkball = true
					end
				end
				if spellId == 231814 then -- orange-dunkball
					--print('orange-dunkball')
					local targetname, targetserver = UnitFullName('arena3')
					if targetserver == nil then
					
					else
						targetname = targetname..'-'..targetserver 
					end
					local playernumber = PvPGrid:getPlayernumber(targetname)
					if playernumber ~= 0 then
						PvPGrid:setflag('orange_dunkball', playernumber)
						orange_dunkball = true
					end
				end
				if spellId == 231813 then -- green-dunkball
					--print('green-dunkball')
					local targetname, targetserver = UnitFullName('arena3')
					if targetserver == nil then
					
					else
						targetname = targetname..'-'..targetserver 
					end
					local playernumber = PvPGrid:getPlayernumber(targetname)
					if playernumber ~= 0 then
						PvPGrid:setflag('green_dunkball', playernumber)
						green_dunkball = true
					end
				end
				if currentMapId == 856 then	
					local spellId2 = select(11, UnitDebuff('arena'..j, i))
					local val2 = select(18, UnitDebuff('arena'..j, i))
					--if spellId ~= nil then
						--print(spellId)
					--end
					if spellId2 == 121164 then -- blueorb 1
						local targetname, targetserver = UnitFullName('arena1')
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							local text = 'x'.. 1+val2/100
							PvPGrid.mainframe['blueorb'].fontname:SetText(text)
							PvPGrid:setflag('blueorb', playernumber)
							
							showorb_blue = true
						end
					end
					if spellId2 == 121175 then -- purpleorb 2
						local targetname, targetserver = UnitFullName('arena2')
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							local text = 'x'.. 1+val2/100
							PvPGrid.mainframe['purpleorb'].fontname:SetText(text)
							PvPGrid:setflag('purpleorb', playernumber)
							
							showorb_purple = true
						end
					end
					if spellId2 == 121177 then -- orangeorb 4
						local targetname, targetserver = UnitFullName('arena4')
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							local text = 'x'.. 1+val2/100
							PvPGrid.mainframe['orangeorb'].fontname:SetText(text)
							PvPGrid:setflag('orangeorb', playernumber)
							
							showorb_orange = true
						end
					end
					if spellId2 == 121176 then -- greenorb 3
						local targetname, targetserver = UnitFullName('arena3')
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							local text = 'x'.. 1+val2/100
							PvPGrid.mainframe['greenorb'].fontname:SetText(text)
							PvPGrid:setflag('greenorb', playernumber)
							
							showorb_green = true
						end
					end
					
				end
				
			end
		end
		if showflag_alliance == false then
			PvPGrid:HideFlag('allianceflag')
		end
		if showflag_horde == false then
			PvPGrid:HideFlag('hordeflag')
		end
		if showflag_nether == false then
			PvPGrid:HideFlag('netherflag')
		end
		
		if showorb_blue == false then
			PvPGrid:HideFlag('blueorb')
		end
		if showorb_purple == false then
			PvPGrid:HideFlag('purpleorb')
		end
		if showorb_orange == false then
			PvPGrid:HideFlag('orangeorb')
		end
		if showorb_green == false then
			PvPGrid:HideFlag('greenorb')
		end
		
		--print('update')
		if PvPGrid.insicooldown then
			for i, data in ipairs(PvPGrid.insicooldown) do
				local framename, endtime, insi2 = strsplit("|", data)
				local duration = tonumber(endtime)- GetTime()
				insi2 = tonumber(insi2)
				if duration >= 0 then
					if insi2 ~= 2 then
						PvPGrid.mainframe[framename].insi.time.font:Show()
						PvPGrid.mainframe[framename].insi.time:SetHideCountdownNumbers(true)
					else
						PvPGrid.mainframe[framename].insi2.time.font:Show()
						PvPGrid.mainframe[framename].insi2.time:SetHideCountdownNumbers(true)
					end
					if duration >= 10 then
						if duration >= 60 then
							local minutes = math.floor(duration / 60)
							duration = math.floor(duration % 60)
							if duration < 10 then
								if insi2 ~= 2 then
									PvPGrid.mainframe[framename].insi.time.font:SetText(string.format("%.0f", minutes)..':0'..string.format("%.0f", duration))--..':'..duration)
								else
									PvPGrid.mainframe[framename].insi2.time.font:SetText(string.format("%.0f", minutes)..':0'..string.format("%.0f", duration))--..':'..duration)
								end
							else
								if insi2 ~= 2 then
									PvPGrid.mainframe[framename].insi.time.font:SetText(string.format("%.0f", minutes)..':'..string.format("%.0f", duration))--..':'..duration)
								else
									PvPGrid.mainframe[framename].insi2.time.font:SetText(string.format("%.0f", minutes)..':'..string.format("%.0f", duration))--..':'..duration)
								end
							end
						else
							duration = math.floor(duration)
							if insi2 ~= 2 then
								PvPGrid.mainframe[framename].insi.time.font:SetText(string.format("%.0f", duration))
							else
								PvPGrid.mainframe[framename].insi2.time.font:SetText(string.format("%.0f", duration))
							end
						end
					else
						if insi2 ~= 2 then
							PvPGrid.mainframe[framename].insi.time.font:SetText(string.format("%.1f", duration))
						else
							PvPGrid.mainframe[framename].insi2.time.font:SetText(string.format("%.1f", duration))
						end
					end
				else
					table.remove(PvPGrid.insicooldown, i)
					if insi2 ~= 2 then
						PvPGrid.mainframe[framename].insi.time.font:Hide()
					else
						PvPGrid.mainframe[framename].insi2.time.font:Hide()
					end
				end
				-- --PvPGrid.mainframe[framename].insitime:SetText(duration)
					-- PvPGrid.mainframe[framename].insitime:Show()
				-- end
			end	
		end		
	end)
	
	
	PvPGrid.mainframe.fontname = PvPGrid.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	PvPGrid.mainframe.fontname:SetPoint("TOPLEFT", 0, 0)
	PvPGrid.mainframe.fontname:SetText('PvPGrid')
	PvPGrid.mainframe.fontname:SetTextColor(1, 1, 1, 0.6)
	PvPGrid.mainframe.fontname:SetFont("Fonts\\FRIZQT__.ttf" , 10, "OUTLINE")
end

function PvPGrid:set_dunkball(ballname, targetname)
	local playernumber = PvPGrid:getPlayernumber(targetname)
	if playernumber ~= 0 then
		PvPGrid:setflag(ballname, playernumber)
		ballname = true
	end
end

function PvPGrid:getPlayernumber(playername)
	for i = 1 , 15 , 1 do
		if PvPGrid.playergrid[i] then
			if PvPGrid.playergrid[i].name == playername then
				return i
			end
		end
	end
	return 0
end

function PvPGrid:create_playerframes()
	local height = self.db.profile.frameheight
	local width = self.db.profile.framewidth
	local fontsize = self.db.profile.fontsize 
	for i=1, 15, 1 do
		local framename = 'enemyplayer'..i
		self.mainframe[framename] = CreateFrame("Button", framename, self.mainframe, "SecureActionButtonTemplate")
		self.mainframe[framename]:SetPoint("TOPLEFT", 0, -10-(i-1)*height)
		self.mainframe[framename]:SetSize(width , height)
		--self.mainframe[framename]:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8"})
		--self.mainframe[framename]:SetBackdropColor(0.1*(i-1), 0, 0, 0.5)
		self.mainframe[framename]:RegisterForClicks("AnyUp")
		self.mainframe[framename]:SetAttribute("type1", "macro")
		self.mainframe[framename]:SetAttribute("macrotext1", "")
		self.mainframe[framename]:SetAttribute("type2", "macro")
		self.mainframe[framename]:SetAttribute("macrotext2", "")
		self.mainframe[framename]:SetAttribute("type3", "macro")
		self.mainframe[framename]:SetAttribute("macrotext3", "")
		--self.mainframe[framename]:SetMinMaxValues(0, 1)
		
		self.mainframe[framename].health = CreateFrame('StatusBar', nil, self.mainframe[framename])
		self.mainframe[framename].health:SetPoint('CENTER', 0, 0)
		self.mainframe[framename].health:SetSize(width , height)
		self.mainframe[framename].health:SetStatusBarTexture(media:Fetch("statusbar", self.db.profile.statusbarframe))
		self.mainframe[framename].health:SetBackdrop({
			bgFile = "Interface/Buttons/GreyscaleRamp64",
		});
		self.mainframe[framename].health:SetBackdropBorderColor(1,1,1,1);
		self.mainframe[framename].health:SetBackdropColor(0, 0, 0, 0.15)
		self.mainframe[framename].health:SetMinMaxValues(0, 1)
		self.mainframe[framename].health:SetValue(1)
		self.mainframe[framename].health:SetStatusBarColor(1,1,1,1);
		self.mainframe[framename].health:SetFrameStrata('LOW')
	
		self.mainframe[framename].fontpercent = self.mainframe[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
		self.mainframe[framename].fontpercent:SetPoint("LEFT", 1, 0)
		local fontpercenttext = ''
		if self.db.profile.percenttext == 'VALUE' or self.db.profile.percenttext == 'PERCENT' then
			fontpercenttext = '100'
		end
		if self.db.profile.percenttext == 'PERCENT' then
			fontpercenttext = fontpercenttext..'%'
		end
		self.mainframe[framename].fontpercent:SetText(fontpercenttext)
		self.mainframe[framename].fontpercent:SetTextColor(1, 1, 1)
		self.mainframe[framename].fontpercent:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
		
		self.mainframe[framename].fontname = self.mainframe[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
		self.mainframe[framename].fontname:SetPoint("CENTER", 20, 0)
		self.mainframe[framename].fontname:SetText(i)
		self.mainframe[framename].fontname:SetTextColor(1, 1, 1)
		self.mainframe[framename].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
		
		self.mainframe[framename].roleicon = self.mainframe[framename]:CreateTexture(nil, "OVERLAY")
		self.mainframe[framename].roleicon:SetPoint("TOPLEFT", -height*2-2, 0)
		self.mainframe[framename].roleicon:SetSize(height , height)
		self.mainframe[framename].roleicon:SetTexture([[Interface\LFGFRAME\UI-LFG-ICON-ROLES]])
		self.mainframe[framename].roleicon:SetTexCoord(0, 0.25, 0.5, 0.75)
		if PvPGrid.db.profile.roleicon == false then
			self.mainframe[framename].roleicon:Hide()
		end
		
		self.mainframe[framename].specicon = self.mainframe[framename]:CreateTexture(nil, "OVERLAY")
		self.mainframe[framename].specicon:SetPoint("TOPLEFT", -height-1, 0)
		self.mainframe[framename].specicon:SetSize(height , height)
		self.mainframe[framename].specicon:SetTexture([[Interface\ICONS\Trade_Engineering]])
		if PvPGrid.db.profile.specicon == false then
			self.mainframe[framename].specicon:Hide()
			self.mainframe[framename].roleicon:SetPoint("TOPLEFT", -height-1, 0)
		end
		
		self.mainframe[framename]:Hide()
		
		self.mainframe[framename].fonttargetcount = self.mainframe[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
		self.mainframe[framename].fonttargetcount:SetPoint("Right", 1, 0)
		self.mainframe[framename].fonttargetcount:SetText(0)
		self.mainframe[framename].fonttargetcount:SetTextColor(1, 1, 1)
		self.mainframe[framename].fonttargetcount:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
		
		self.mainframe[framename].insi = CreateFrame('Frame', 'InsiFrame'..i , self.mainframe[framename])
		self.mainframe[framename].insi:SetPoint("TOPRIGHT", height+1, 0)
		self.mainframe[framename].insi:SetSize(height , height)
		
		self.mainframe[framename].insi.Icon = self.mainframe[framename]:CreateTexture(nil, "OVERLAY")
		self.mainframe[framename].insi.Icon:SetPoint("TOPRIGHT", height+1, 0)
		self.mainframe[framename].insi.Icon:SetSize(height , height)
		self.mainframe[framename].insi.Icon:SetTexture([[Interface\ICONS\inv_misc_questionmark]])
		self.mainframe[framename].insi.Icon:Hide()
		
		self.mainframe[framename].insi.time = CreateFrame("Cooldown", framename..' insicooldown', self.mainframe[framename].insi, "CooldownFrameTemplate")
		self.mainframe[framename].insi.time:SetHideCountdownNumbers(true)
		
		self.mainframe[framename].insi.time.font = self.mainframe[framename].insi.time:CreateFontString(nil, "OVERLAY", "GameTooltipText")
		self.mainframe[framename].insi.time.font:SetPoint("Center", 0, 0)
		self.mainframe[framename].insi.time.font:SetText()
		self.mainframe[framename].insi.time.font:SetTextColor(1, 1, 1)
		self.mainframe[framename].insi.time.font:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
		
		self.mainframe[framename].insi2 = CreateFrame('Frame', 'InsiFrame2'..i , self.mainframe[framename])
		self.mainframe[framename].insi2:SetPoint("TOPRIGHT", 2*height+2, 0)
		self.mainframe[framename].insi2:SetSize(height , height)
		
		self.mainframe[framename].insi2.Icon = self.mainframe[framename]:CreateTexture(nil, "OVERLAY")
		self.mainframe[framename].insi2.Icon:SetPoint("TOPRIGHT", 2*height+2, 0)
		self.mainframe[framename].insi2.Icon:SetSize(height , height)
		self.mainframe[framename].insi2.Icon:SetTexture([[Interface\ICONS\inv_misc_questionmark]])
		self.mainframe[framename].insi2.Icon:Hide()
		
		self.mainframe[framename].insi2.time = CreateFrame("Cooldown", framename..' insicooldown2', self.mainframe[framename].insi2, "CooldownFrameTemplate")
		self.mainframe[framename].insi2.time:SetHideCountdownNumbers(true)
		
		self.mainframe[framename].insi2.time.font = self.mainframe[framename].insi2.time:CreateFontString(nil, "OVERLAY", "GameTooltipText")
		self.mainframe[framename].insi2.time.font:SetPoint("Center", 0, 0)
		self.mainframe[framename].insi2.time.font:SetText()
		self.mainframe[framename].insi2.time.font:SetTextColor(1, 1, 1)
		self.mainframe[framename].insi2.time.font:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
		
		self.mainframe[framename].crown = self.mainframe[framename]:CreateTexture(nil, "OVERLAY")
		self.mainframe[framename].crown:SetPoint("TOPLEFT", height+5, 0)
		self.mainframe[framename].crown:SetSize(height , height)
		self.mainframe[framename].crown:SetTexture([[Interface\LFGFrame\LFGROLE]])
		self.mainframe[framename].crown:SetTexCoord(0, 0.25, 0, 1);
		self.mainframe[framename].crown:Hide()
		--self.mainframe[framename].insi.time:SetFrameStrata('HIGH')
		
		--self.mainframe[framename].insi.time:SetPoint("RIGHT", height-5, 0)
		--self.mainframe[framename].insitime:SetText(0)
		--self.mainframe[framename].insitime:SetTextColor(1, 1, 1)
		--self.mainframe[framename].insi.time:SetFont(media:Fetch("font", self.db.profile.mainfont), fontsize, "OUTLINE")
		--self.mainframe[framename].insitime:Hide()
	end
end

function PvPGrid:updategrid()
	if not InCombatLockdown() then
		for i=1, 15, 1 do
			local framename = 'enemyplayer'..i
			self.mainframe[framename]:Hide()
			if not self.playergrid[i] then
				
			else
				self.mainframe[framename]:Show()
				if PvPGrid.db.profile.servername then
					self.mainframe[framename].fontname:SetText(self:formatUpToX(self.playergrid[i].name, self.db.profile.wordwrap))
				else
					local playername, servername = strsplit("-", PvPGrid.playergrid[i].name)
					self.mainframe[framename].fontname:SetText(playername)
				end
				for j = 1, #PvPGrid.Classinfos[self.playergrid[i].class] do
					if self.playergrid[i].spec == PvPGrid.Classinfos[self.playergrid[i].class][j].specname then
						--print(self.playergrid[i].name..' is '..self.playergrid[i].spec)
						self.mainframe[framename].specicon:SetTexture(PvPGrid.Classinfos[self.playergrid[i].class][j].specicon)
						if PvPGrid.Classinfos[self.playergrid[i].class][j].specrole == "DAMAGER" then
							self.mainframe[framename].roleicon:SetTexCoord(0.25, 0.5, 0.25, 0.5)
						elseif PvPGrid.Classinfos[self.playergrid[i].class][j].specrole == "HEALER" then
							self.mainframe[framename].roleicon:SetTexCoord(0.25, 0.5, 0, 0.25)
						elseif PvPGrid.Classinfos[self.playergrid[i].class][j].specrole == "TANK" then
							self.mainframe[framename].roleicon:SetTexCoord(0, 0.25, 0.25, 0.5)
						else
							self.mainframe[framename].roleicon:SetTexCoord(0, 0.25, 0.5, 0.75)
						end
					end
				end
				local alphastatusbar =  0.3
				if testmode then
					alphastatusbar = 1
				end
				local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
				if GetCVar("nameplateShowEnemies") == '0' or PvPGrid.db.profile.barcolor == true then
					self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)
				else
					self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, alphastatusbar)
				end
				
				self:setkeybind(PvPGrid.db.profile.leftbutton, self.db.profile.leftbuttontype, 1, i, framename)
				self:setkeybind(PvPGrid.db.profile.rightbutton, self.db.profile.rightbuttontype, 2, i, framename)
				self:setkeybind(PvPGrid.db.profile.middlebutton, self.db.profile.middlebuttontype, 3, i, framename)
				
				
			end
		end
		if GetCVar("nameplateShowEnemies") == '1' then
			for k = 1 , 15, 1 do
				local targetname, targetserver = UnitFullName('nameplate'..k)
				if targetserver == nil then
		
				else
					targetname = targetname..'-'..targetserver 
				end
				if targetname ~= nil then
					for i=1, 15, 1 do
						local framename = 'enemyplayer'..i
						if self.playergrid[i] then
							if self.playergrid[i].name == targetname then
								local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
								self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)
							end
						end
					end
				end
			end
		else
			for i=1, 15, 1 do
				local framename = 'enemyplayer'..i
				if self.playergrid[i] then
					local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
					self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)
				end
			end
		end
	end
end

function PvPGrid:setkeybind(button, buttontype,  buttonnumber, i, framename)
	if buttontype == 'TARGET' then
		PvPGrid.mainframe[framename]:SetAttribute('macrotext'..buttonnumber,
		'/targetexact'..' '..PvPGrid.playergrid[i].name )
	elseif buttontype == 'FOCUS' then
		PvPGrid.mainframe[framename]:SetAttribute('macrotext'..buttonnumber,
		'/targetexact '..PvPGrid.playergrid[i].name..'\n'..'/focus'..'\n'..'/targetlasttarget'	)
	elseif buttontype == 'COSTUM' then
		PvPGrid.mainframe[framename]:SetAttribute('macrotext'..buttonnumber, button )
	elseif buttontype == 'MOUSEOVER' then
		PvPGrid.mainframe[framename]:SetAttribute('macrotext'..buttonnumber,
			'/targetexact '..self.playergrid[i].name..'\n'..
			button..'\n'..
			'/targetlasttarget' )
	else 
		PvPGrid.mainframe[framename]:SetAttribute('macrotext'..buttonnumber,'')
	end
end

function PvPGrid:default_players()
	self.playergrid = {}
	for i=2, 10, 1 do
		self.playergrid[i] = {}
	end
	self.playergrid[1] = {
		name = 'Rivah',
		class = 'MAGE',
		classnumber = 8,
		spec = 'Arkan',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[2] = {
		name = 'Armicron',
		class = 'DRUID',
		classnumber = 11,
		spec = 'Wildheit',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[3] = {
		name = 'Wyrlinia',
		class = 'DRUID',
		classnumber = 11,
		spec = 'Wächter',
		specrole = 'TANK',
		maxhealth = 1,
	}
	self.playergrid[4] = {
		name = 'Deex',
		class = 'MAGE',
		classnumber = 8,
		spec = 'Feuer',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[5] = {
		name = '纯洁的小猴-Chinese',
		class = 'WARRIOR',
		classnumber = 1,
		spec = 'Furor',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[6] = {
		name = 'Летнийдождь-Russian',
		class = 'WARLOCK',
		classnumber = 9,
		spec = 'Zerstörung',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[7] = {
		name = 'Unrealrules-Ungoro',
		class = 'PRIEST',
		classnumber = 5,
		spec = 'Heilig',
		specrole = 'HEALER',
		maxhealth = 1,
	}
	self.playergrid[8] = {
		name = '血腥馬克-Taiwanese',
		class = 'HUNTER',
		classnumber = 3,
		spec = 'Treffsicherheit',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[9] = {
		name = 'Groni',
		class = 'PALADIN',
		classnumber = 2,
		spec = 'Vergeltung',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[10] = {
		name = '사진작가-Korean',
		class = 'ROGUE',
		classnumber = 4,
		spec = 'Meucheln',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
end





function PvPGrid:update_playerinfo()
	PvPGrid:update_player()
	local playernumbers = GetNumBattlefieldScores()
	PvPGrid.playergrid = {}
	local j = 1
	for i = 1, playernumbers do
		local name,_,_,_,_,faction,_,_,class, _ ,_,_,_,_,_,spec = GetBattlefieldScore(i)
		local classnumber = 13
		if faction ~= PvPGrid.player.faction then
			--print(UnitGUID(name))
			PvPGrid.playergrid[j] = {}
			local specrole = ''
			for j = 1, #PvPGrid.Classinfos[class] do
				if spec == PvPGrid.Classinfos[class][j].specname then
					specrole = PvPGrid.Classinfos[class][j].specrole
					classnumber = PvPGrid.classids[class]
					--print(name..' '..class)
				end
			end
			
			PvPGrid.playergrid[j] = {
				name = name,
				class = class,
				classnumber = classnumber,
				specrole = specrole,
				spec = spec,
				maxhealth = 1,
				guid = '',
			}
			j = j +1
		end
		
		--print(name..': '..class..' '..spec..' '..faction)
	end
end

function PvPGrid:showgrid()
	if testmode then
		self:default_players()
	else
		self:update_playerinfo()
	end
	self:sort_players()
	self:updategrid()
	if testmode then
		local fontpercenttext = ''
		if self.db.profile.percenttext == 'VALUE' or self.db.profile.percenttext == 'PERCENT' then
			fontpercenttext = '33'
		end
		if self.db.profile.percenttext == 'PERCENT' then
			fontpercenttext = fontpercenttext..'%'
		end
		self.mainframe['enemyplayer5'].fontpercent:SetText(fontpercenttext)
		self.mainframe['enemyplayer5'].health:SetValue(11/33)
		local classColor = NORMAL_FONT_COLOR;	
									
		--self.mainframe['enemyplayer5'].health:SetBackdropColor(0,0,0, 0.15)
		self.mainframe['enemyplayer5'].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)							
	end
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end
function PvPGrid:sort_players(...)
	--local isfirst = ... or 0
	
	local playerdata = deepcopy(self.playergrid)
	allsorted = true
	for i = 1, 15, 2 do
		if playerdata[i+1] then
			local islower = self:sort(playerdata[i], playerdata[i+1])
			if islower == true then
				self.playergrid[i] = deepcopy(playerdata[i+1])
				self.playergrid[i+1] = deepcopy(playerdata[i])
				allsorted = false
			end
		end
	end
	playerdata = deepcopy(self.playergrid)
	for i = 2, 15, 2 do
		if playerdata[i+1] then
			local islower = self:sort(playerdata[i], playerdata[i+1])
			if islower == true then
				self.playergrid[i] = deepcopy(playerdata[i+1])
				self.playergrid[i+1] = deepcopy(playerdata[i])
				allsorted = false
			end
		end
	end
	if allsorted == false then
		PvPGrid:sort_players()
	end
end

function PvPGrid:sort(a, b)
	if self:specrolevalue(a.specrole) ~= nil and self:specrolevalue(b.specrole) ~= nil then
		if self:specrolevalue(a.specrole) == self:specrolevalue(b.specrole) then
			if a.classnumber == b.classnumber then
				if a.name > b.name then
					return true
				end
			elseif a.classnumber > b.classnumber then
				return true
			end
		elseif self:specrolevalue(a.specrole) > self:specrolevalue(b.specrole) then
			return true
		end
	end
	return false
end

function PvPGrid:specrolevalue(role)
	if role == 'DAMAGER' then
		return 3
	elseif role == 'HEALER' then
		return 1
	elseif role == 'TANK' then
		return 2
	else
		--print('Specrole Error '..role)
	end
end

function PvPGrid:PvP_Zone_check()
	if not InCombatLockdown() then
		local _, area = IsInInstance()
		if area == "pvp" then
			PvPGrid:onBG()
			PvPGrid.mainframe:Show()
			PvPGrid:resetdatas()
		elseif area == "arena" then
			--print("arena true")
			local _, _, _, _, maxplayer = GetInstanceInfo()
			--print(maxplayer)
			--print(GetInstanceInfo())
			if maxplayer == 15 or maxplayer == 5 then
				PvPGrid:onBG()
				PvPGrid.mainframe:Show()
				PvPGrid:resetdatas()
			end
		else
			if not testmode then
				PvPGrid.mainframe:Hide()
			end
		end
	end
	if PvPGrid.loopq == 0 then
		--print('true1')
		PvPGrid.loopq = GetTime()
	end
end

function PvPGrid:onBG()
	PvPGrid:showgrid()
end



function PvPGrid:resetdatas()
	PvPGrid.insicooldown = {}
	for i=1, 15, 1 do
		local framename = 'enemyplayer'..i
		if self.mainframe[framename] then
			self.mainframe[framename].health:SetValue(1)
			local fontpercenttext = ''
			if self.db.profile.percenttext == 'VALUE' or self.db.profile.percenttext == 'PERCENT' then
				fontpercenttext = '100'
			end
			if self.db.profile.percenttext == 'PERCENT' then
				fontpercenttext = fontpercenttext..'%'
			end
			self.mainframe[framename].fontpercent:SetText(fontpercenttext)
			
			self.mainframe[framename].insi.Icon:Hide()
			self.mainframe[framename].insi2.Icon:Hide()
			self.mainframe[framename].crown:Hide()
			self.mainframe['green_dunkball']:Hide()
			self.mainframe['purple_dunkball']:Hide()
			self.mainframe['orange_dunkball']:Hide()
		end
	end					
end

function PvPGrid:check_leader(unit)
	if unit then
		local targetname, targetserver = UnitFullName(unit)
		
		if targetserver == nil then
		
		else
			targetname = targetname..'-'..targetserver 
		end
		if UnitLeadsAnyGroup(unit) then
			self:show_leader_crown(targetname)
		else
			self:hide_leader_crown(targetname)	
		end
		
		targetname, targetserver = UnitFullName(unit..'target')
		
		if targetserver == nil then
		
		else
			targetname = targetname..'-'..targetserver 
		end
		if UnitLeadsAnyGroup(unit..'target') then
			self:show_leader_crown(targetname)
		else
			self:hide_leader_crown(targetname)	
		end
		
	end
end

function PvPGrid:show_leader_crown(targetname)	
	local playernumber = self:getPlayernumber(targetname)
	if playernumber ~= 0 then
		local framename = 'enemyplayer'..playernumber
		self.mainframe[framename].crown:Show()
	end
end

function PvPGrid:hide_leader_crown(targetname)	
	local playernumber = self:getPlayernumber(targetname)
	if playernumber ~= 0 then
		local framename = 'enemyplayer'..playernumber
		self.mainframe[framename].crown:Hide()
	end
end

function PvPGrid:hide_dunkballs(frame_id)
	ballname = false
	self.mainframe[frame_id].fontname:Hide()
end

function PvPGrid:target_check(...)
	local unit = (...)
	local targetunit = unit..'target'
	local targetguid = UnitGUID(targetunit)
	local targetname, targetserver = UnitFullName(targetunit)
	
	for i = 1, 40, 1 do
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, canStealOrPurge, nameplateShowPersonal, spellId = UnitAura(unit, i)
		local targetname2, targetserver2 = UnitFullName(unit)
		if targetserver2 == nil then
		else
			targetname2 = targetname2..'-'..targetserver2 
		end
		
		if spellId == 231813 then -- green-dunkball
			--PvPGrid:set_dunkball('green_dunkball', targetname2)
		elseif spellId == 231814 then -- orange-dunkball
			--PvPGrid:set_dunkball('orange_dunkball', targetname2)
		elseif spellId == 231529 then -- purple-dunkball
			--PvPGrid:set_dunkball('purple_dunkball', targetname2)
		else
			--PvPGrid:hide_dunkballs()
		end
	end
	
	if targetserver == nil then
	
	else
		targetname = targetname..'-'..targetserver 
	end
	self:check_leader(unit)
	if targetguid ~= nil then
		local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",targetguid);
		if type == 'Player' then
			--print('target is '..targetname)
			if PvPGrid.playerinfos[targetname] == nil then --insert
				PvPGrid.playerinfos[targetname] = {}
				PvPGrid.playerinfos[targetname].guid = targetguid
				PvPGrid.playerinfos[targetname].medallions = {}
				PvPGrid:update_health(targetunit)
			else --update
				PvPGrid:update_health(targetunit)
			end
			
			--print(targetunit..' '..PvPGrid.targets[unit].name)
		end
	end
	
	if PvPGrid.targets[unit] == nil then
		PvPGrid.targets[unit] = {}
		PvPGrid.targets[unit].name = ''
	end
	PvPGrid.targets[unit].name = targetname
	PvPGrid:update_targets()
end

function PvPGrid:update_targets()
	for i=1, 15, 1 do
		local framename = 'enemyplayer'..i
		self.mainframe[framename].fonttargetcount:SetText(0)
	end
	for i=1, 15, 1 do
		local unit = 'raid'..i
		if PvPGrid.targets[unit] ~= 'nil' then
			for j=1, 15, 1 do
				if self.playergrid[j] and  PvPGrid.targets[unit] then
					
					if self.playergrid[j].name == PvPGrid.targets[unit].name then
						
						local framename = 'enemyplayer'..j
						local count = tonumber(self.mainframe[framename].fonttargetcount:GetText()) +1
						self.mainframe[framename].fonttargetcount:SetText(count)
					end
				end
			end
		end
	end
end

function PvPGrid:update_health(unit, ...)
	local targetguid = UnitGUID(unit)
	if targetguid ~= nil then
		local targetname, targetserver = UnitFullName(unit)
		if targetserver == nil then
		
		else
			targetname = targetname..'-'..targetserver 
		end
		local health = UnitHealth(unit)
		local maxhealth = UnitHealthMax(unit)
		if PvPGrid.playerinfos[targetname] then
			PvPGrid.playerinfos[targetname].maxhealth = maxhealth
			PvPGrid.playerinfos[targetname].curhealth = health
			for i=1, 15, 1 do
				local framename = 'enemyplayer'..i
				if self.playergrid[i] then
					if  self.playergrid[i].name == targetname then
						self.mainframe[framename].health:SetValue(health/maxhealth)
						local fontpercenttext = ''
						if self.db.profile.percenttext == 'VALUE' or self.db.profile.percenttext == 'PERCENT' then
							fontpercenttext = string.format("%.0f", health/maxhealth*100)
						end
						if self.db.profile.percenttext == 'PERCENT' then
							fontpercenttext = fontpercenttext..'%'
						end
						self.mainframe[framename].fontpercent:SetText(fontpercenttext)
						local healthbarcolor = ... or 'nothing'
						if healthbarcolor == 'nothing' then
						
						elseif healthbarcolor == 'show' then
							for j = 1, #PvPGrid.Classinfos[self.playergrid[i].class] do
								if self.playergrid[i].spec == PvPGrid.Classinfos[self.playergrid[i].class][j].specname then
									local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
									self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)
									--self:status(self.playergrid[i].name, true)
								end
							end
						elseif healthbarcolor == 'slice' then
							for j = 1, #PvPGrid.Classinfos[self.playergrid[i].class] do
								if self.playergrid[i].spec == PvPGrid.Classinfos[self.playergrid[i].class][j].specname then
									local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
									local alphastatusbar =  0.3
									if GetCVar("nameplateShowEnemies") == '0' or PvPGrid.db.profile.barcolor == true then
										self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)
									else
										self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, alphastatusbar)
									end
								end
							end
						else
							print('error barcolorinfo')
						end
						--print('healthupdate '..targetname)
					end
				end	
			end
		end
	end
end

function PvPGrid:status(name, status)
	if not PvPGrid.statusactive then
		PvPGrid.statusactive = {}
	end
	local players = PvPGrid.statusactive
	local allrdyin = false
	if players then
		for i = 1, #players do
			if players[i] == name then
				if status == false then
					table.remove(PvPGrid.statusactive, i)
					print('remove '..name)
				elseif status == true then	
					allrdyin = true
					print('alrdyin '..name)
				end
			end
		end
	end
	if allrdyin == false and status == true then
		table.insert(PvPGrid.statusactive, name)
		print('insert '..name)
	end
end

function PvPGrid:show_bar(unit)
	PvPGrid:update_health(unit, 'show')
end

function PvPGrid:slice_bar(unit)
	PvPGrid:update_health(unit, 'slice')
end

function PvPGrid:newcooldown(framename, starttime, duration, ...)
	local insi2 = ... or 0
	if not PvPGrid.insicooldown then
		PvPGrid.insicooldown = {}
	end
	local endtime = starttime+duration
	local data = framename..'|'..endtime..'|'..insi2
	table.insert (PvPGrid.insicooldown, data)
	if insi2 ~= 2 then
		PvPGrid.mainframe[framename].insi.time:SetCooldown(starttime, duration)
		PvPGrid.mainframe[framename].insi.Icon:Show()
	else
		PvPGrid.mainframe[framename].insi2.time:SetCooldown(starttime, duration)
		PvPGrid.mainframe[framename].insi2.Icon:Show()
	end
end

function PvPGrid:combat_log(timestamp,event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName,destF1,destF2, spellId, spellname, ...)
	--print(spellId)
	if event == 'SPELL_CAST_SUCCESS' then
		if spellId == 208683 then -- medallion
			local playernumber = PvPGrid:getPlayernumber(srcName)
			if playernumber ~= 0 then
				local framename = 'enemyplayer'..playernumber
				PvPGrid.mainframe[framename].insi.Icon:SetTexture([[Interface\ICONS\ability_pvp_gladiatormedallion]])
				PvPGrid:newcooldown(framename, GetTime(), 120)
				if PvPGrid.playerinfos[srcName] then
					PvPGrid.playerinfos[srcName].medallions.time = GetTime()+120
					if PvPGrid.playerinfos[srcName] then
						if PvPGrid.playerinfos[srcName].medallions then
							if PvPGrid.playerinfos[srcName].medallions.time2 ~= nil then 
								if PvPGrid.playerinfos[srcName].medallions.time2 < GetTime()+30 then
									PvPGrid:newcooldown(framename, GetTime(), 30)
								end
							end
						end
					end
				end
			end
		elseif spellId == 195710 then -- lvlmedallion
			local playernumber = PvPGrid:getPlayernumber(srcName)
			if playernumber ~= 0 then
				local framename = 'enemyplayer'..playernumber
				PvPGrid.mainframe[framename].insi.Icon:SetTexture([[Interface\ICONS\inv_jewelry_trinket_04]])
				PvPGrid:newcooldown(framename, GetTime(), 180)
				if PvPGrid.playerinfos[srcName] then
					PvPGrid.playerinfos[srcName].medallions.time = GetTime()+180
					if PvPGrid.playerinfos[srcName] then
						if PvPGrid.playerinfos[srcName].medallions then
							if PvPGrid.playerinfos[srcName].medallions.time2 ~= nil then 
								if PvPGrid.playerinfos[srcName].medallions.time2 < GetTime()+30 then
									PvPGrid:newcooldown(framename, GetTime(), 30)
								end
							end
						end
					end
				end
			end
		elseif spellId == 7744 then -- undead racial
			--print(srcName..' undead racial')
			local playernumber = PvPGrid:getPlayernumber(srcName)
			if playernumber ~= 0 then
				local framename = 'enemyplayer'..playernumber
				PvPGrid.mainframe[framename].insi2.Icon:SetTexture([[Interface\ICONS\spell_shadow_raisedead]])
				PvPGrid:newcooldown(framename, GetTime(), 120, 2)
				if PvPGrid.playerinfos[srcName] then
					PvPGrid.playerinfos[srcName].medallions.time2 = GetTime()+120
					if PvPGrid.playerinfos[srcName] then
						if PvPGrid.playerinfos[srcName].medallions then
							if PvPGrid.playerinfos[srcName].medallions.time ~= nil then 
								if PvPGrid.playerinfos[srcName].medallions.time < GetTime()+30 then
									PvPGrid:newcooldown(framename, GetTime(), 30)
								end
							end
						end
					end
				end
			end
		elseif spellId == 59752 then -- human racial
			local playernumber = PvPGrid:getPlayernumber(srcName)
			if playernumber ~= 0 then
				local framename = 'enemyplayer'..playernumber
				PvPGrid.mainframe[framename].insi2.Icon:SetTexture([[Interface\ICONS\spell_shadow_charm]])
				PvPGrid:newcooldown(framename, GetTime(), 120, 2)
				if PvPGrid.playerinfos[srcName] then
					PvPGrid.playerinfos[srcName].medallions.time2 = GetTime()+120
					if PvPGrid.playerinfos[srcName] then
						if PvPGrid.playerinfos[srcName].medallions then
							if PvPGrid.playerinfos[srcName].medallions.time ~= nil then 
								if PvPGrid.playerinfos[srcName].medallions.time < GetTime()+30 then
									PvPGrid:newcooldown(framename, GetTime(), 30)
								end
							end
						end
					end
				end
			end
		end
	end
	if event == 'SPELL_AURA_APPLIED' then
		if spellId == 42292 then -- adaptition
			local playernumber = PvPGrid:getPlayernumber(srcName)
			if playernumber ~= 0 then
				local framename = 'enemyplayer'..playernumber
				PvPGrid.mainframe[framename].insi.Icon:SetTexture([[Interface\ICONS\sha_ability_rogue_sturdyrecuperate]])
				PvPGrid:newcooldown(framename, GetTime(), 60)
				if PvPGrid.playerinfos[srcName] then
					PvPGrid.playerinfos[srcName].medallions.time = GetTime()+60
				end
			end
		elseif spellId == 196029 then -- 20% cc reduce talent
			
			-- if not PvPGrid.insicooldown then
				-- PvPGrid.insicooldown = {}
			-- end
			-- local endtime = GetTime()+120
			-- local data = srcName..'|'..endtime
			-- print(data)
			-- table.insert (PvPGrid.insicooldown, data)
		end
	end
	if spellId == 231813 then
		destName = destName or 'nil'
		PvPGrid:dunkball_change(event, destName, spellId)
	elseif spellId == 231814 then
		destName = destName or 'nil'
		PvPGrid:dunkball_change(event, destName, spellId)
	elseif spellid == 231529 then
		destName = destName or 'nil'
		PvPGrid:dunkball_change(event, destName, spellId)
	end
	if event == 'SPELL_AURA_APPLIED' or event == 'SPELL_AURA_REMOVED' or event == 'SPELL_AURA_REFRESH' or event == 'SPELL_AURA_BROKEN_SPELL' then
		if destName == 'Unrealrules' then
			--if not srcName == 'Unrealrules' then
				local ccs = PvPGrid.spell.ccs
				for j = 1, #ccs do
					if ccs[j] == spellId then
						--print(timestamp..' '..event..' '..spellname..' '..spellId..' '..srcName)
						if event == 'SPELL_AURA_APPLIED' then
							local data = GetTime()..'#'..spellId
							table.insert(PvPGrid.spell.curentccs, data)
						elseif event == 'SPELL_AURA_REMOVED' then
							for i, data in ipairs(PvPGrid.spell.curentccs) do
								local starttime, id = strsplit("#", data)
								if spellId == tonumber(id) then
									local duration = GetTime()-starttime
									duration = math.floor(duration*10+.5)/10
									--print('DURATION: '..duration..' '..spellId..' '..spellname)
									table.remove(PvPGrid.spell.curentccs, i)
									duration = math.floor(duration*10 % 10)
									if duration ~= 0 then
										--print('istalent Relentless?!')
									else
										--print('istalent Medallion/Adaptation?!')
									end
								end
							end
						elseif event == 'SPELL_AURA_REFRESH' then
							for i, data in ipairs(PvPGrid.spell.curentccs) do
								local starttime, id = strsplit("#", data)
								if spellId == tonumber(id) then
									table.remove(PvPGrid.spell.curentccs, i)
									local data = GetTime()..'#'..spellId
									table.insert(PvPGrid.spell.curentccs, data)
								end
							end
						elseif event == 'SPELL_AURA_BROKEN_SPELL' then
							for i, data in ipairs(PvPGrid.spell.curentccs) do
								local starttime, id = strsplit("#", data)
								if spellId == tonumber(id) then
									table.remove(PvPGrid.spell.curentccs, i)
									--print(timestamp..' '..event..' '..spellname..' '..' is broken!')
								end
							end
						end
					end
				end
				
				-- for i = 1 , 40 do
					-- local auraname, rank, icon, count, debuffType, duration, expirationTime, unitCaster  = UnitDebuff("player", i)
					-- expirationTime = expirationTime or 0
					-- duration = duration or 0
					--auraname = auraname or 'nil'
					-- local myduration = expirationTime - GetTime()
					-- if auraname then
						-- print(auraname..' '..duration..' '..expirationTime..' '..myduration)
					-- end
				-- end
			--end
		end
	end
end

function PvPGrid:dunkball_change(event, srcName, spellId)
	if event == 'SPELL_AURA_APPLIED' then
		--print(spellId..' on '..srcName)
		if spellId == 231813 then -- green-dunkball
			PvPGrid:set_dunkball('green_dunkball', targetname2)
		elseif spellId == 231814 then -- orange-dunkball
			PvPGrid:set_dunkball('orange_dunkball', targetname2)
		elseif spellId == 231529 then -- purple-dunkball
			PvPGrid:set_dunkball('purple_dunkball', targetname2)
		end
	elseif event == 'SPELL_AURA_REMOVED' then 
		--print(spellId..' on '..srcName)
		if spellId == 231813 then -- green-dunkball
			PvPGrid:hide_dunkballs('green_dunkball')
		elseif spellId == 231814 then -- orange-dunkball
			PvPGrid:hide_dunkballs('orange_dunkball')
		elseif spellId == 231529 then -- purple-dunkball
			PvPGrid:hide_dunkballs('purple_dunkball')
		end
	else
		print(event..' FAILs')
	end
end


function PvPGrid_OnEvent(self, event, ...)
	if event == 'ZONE_CHANGED_NEW_AREA' then
		PvPGrid:PvP_Zone_check()
	elseif event == "UPDATE_BATTLEFIELD_SCORE" then
		PvPGrid:onBG()
	elseif event == "UNIT_TARGET" then
		PvPGrid:target_check(...)
		local arg1 = ...
		--print(arg1)
	elseif event == "UNIT_HEALTH_FREQUENT" then
		PvPGrid:update_health(...)	
	elseif event == "NAME_PLATE_UNIT_ADDED" then
		PvPGrid:show_bar(...)
	elseif event == "NAME_PLATE_UNIT_REMOVED" then
		PvPGrid:slice_bar(...)
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		PvPGrid:combat_log(...)
	end
	if PvPGrid.loopq ~= 0 then
		local time = GetTime()
		local dataTIme = PvPGrid.loopq + 3
		if time > dataTIme then
			PvPGrid:PvP_Zone_check()
			--print('check later')
			PvPGrid.loopq = 0
		else
			--print(GetTime()..'false')
		end
	end
end

